﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Globalization;
using System.Security.Cryptography;
using System.Text;

namespace Ozeki
{
    public static partial class OzCommonStrings
    {
        public static string UpperFirst(string input)
        {
            if (!string.IsNullOrEmpty(input))
                return input[0].ToString().ToUpper() + input.Substring(1);

            return string.Empty;
        }

        public static string UcFirst(string s)
        {
            if (s == null || s.Length == 0) return String.Empty;
            if (!isLetter(s[0])) return s;
            return s.Length > 0 ? s[0].ToString().ToUpper() + s.Substring(1) : String.Empty;
        }

        public static string LcFirst(string s)
        {
            return s.Length > 0 ? s[0].ToString().ToLower() + s.Substring(1) : String.Empty;
        }

        public static bool isLetter(char c)
        {
            if (c >= 'a' && c <= 'z') return true;
            if (c >= 'A' && c <= 'Z') return true;
            return false;
        }

        public static bool IsAllCaps(string input)
        {
            return IsAllCaps(input, input.Length);
        }

        public static bool IsAllCaps(string input, int maxCheckLength)
        {
            for (int i = 0; i < input.Length && i<maxCheckLength; i++)
            {
                if (!Char.IsLetter(input[i])) break;
                if (Char.IsLetter(input[i]) && !Char.IsUpper(input[i]))
                    return false;
            }
            return true;
        }

        public static string LcFirstIfNotAllCaps(string s)
        {
            return (IsAllCaps(s,2)) ? s : LcFirst(s);
        }

        public static string LcFirstAndSeparateByUc(string s)
        {
            StringBuilder sb = new StringBuilder();

            var length = s.Length;

            for (int x = 0; x < length; x++)
            {
                if (x == 0)
                {
                    sb.Append(char.ToLower(s[x]));
                }
                else if (char.IsUpper(s[x]))
                {
                    var next = x + 1;
                    if(length < next)
                    {
                        var nextChar = s[next];
                        if(char.IsUpper(nextChar))
                        {
                            sb.Append(char.ToLower(s[x]));
                            continue;
                        }
                    }

                    sb.Append(" ");
                    sb.Append(char.ToLower(s[x]));
                }
                else
                {
                    sb.Append(s[x]);
                }
            }
            return sb.ToString();
        }
    }
}
