﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Ozeki
{
    partial class OzCommonStrings
    {
        public static string[] ParseArguments(string data, int maxLength = int.MaxValue)
        {
            if (string.IsNullOrWhiteSpace(data))
                return new string[0];
            var chars = data.ToCharArray();
            var inDoubleQuotes = false;
            var buffer = new StringBuilder();
            var arguments = new List<string>();
            for (var i = 0; i < chars.Length; i++)
            {
                var c = chars[i];
                if (IsDelimiter(c) && !inDoubleQuotes)
                {
                    var argument = buffer.ToString();
                    buffer.Clear();
                    if (string.IsNullOrEmpty(argument))
                        continue;
                    arguments.Add(argument);
                    if (arguments.Count == maxLength)
                        return arguments.ToArray();
                    continue;
                }
                buffer.Append(c);
                if (c == '"' && !inDoubleQuotes)
                {
                    inDoubleQuotes = true;
                    continue;
                }
                if (c == '"' && inDoubleQuotes)
                {
                    inDoubleQuotes = false;
                    continue;
                }
            }
            if (arguments.Count < maxLength && buffer.Length > 0)
                arguments.Add(buffer.ToString());
            return arguments.ToArray();
        }

        static bool IsDelimiter(char c)
        {
            if (c == ',') return true;
            if (c == ';') return true;
            if (c == '=') return true;
            if (c == ' ') return true;
            if (char.IsWhiteSpace(c)) return true;
            return false;
        }
    }
}
