﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Ozeki
{
    public static partial class OzCommonStrings
    {
        public static string ToPhoneNumber(string s)
        {
            return ToNumberEx(s, true);
        }

        public static bool isPhoneNumber(string s)
        {
            return (ToPhoneNumber(s) == s);
        }

        public static bool isPhoneNumberInternational(string s)
        {
            if (s.Length < 6) return false;
            if (s[0] != '+') return false;
            for (int x = 1; x < s.Length; x++)
            {
                if (s[x] < '0' || s[x] > '9') return false;
            }
            return true;
        }

        public static byte[] EncodePhoneNumberAsString(string phoneNumber, bool withLengthByte)
        {
            var ret = new List<byte>();
            phoneNumber = ToPhoneNumber(phoneNumber);


            if (phoneNumber.Length <= 1) return new byte[0];

            if (phoneNumber[0] == '+')
            {
                ret.Add(0x91);
                phoneNumber = phoneNumber.Substring(1);
            }
            else
            {
                ret.Add(0x81);
            }

            int numberLength = phoneNumber.Length;
            if (IsOdd(phoneNumber.Length))
            {
                phoneNumber += "F";
            }

            for (int x = 0; x < phoneNumber.Length; x += 2)
            {
                var c = (char)(FromHexChar(phoneNumber[x + 1]) * 16 + FromHexChar(phoneNumber[x]));
                ret.Add((byte)c);
            }

            if (withLengthByte)
            {
                ret.Insert(0, (byte)numberLength);
            }

            return ret.ToArray();
        }

        public static byte[] EncodePhoneNumber(string phoneNumber, bool withLengthByte)
        {
            var ret = EncodePhoneNumberAsString(phoneNumber, withLengthByte);
            return ret;
        }


    }
}
