﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Ozeki
{
    partial class OzCommonStrings
    {
        //**********************************************************************
        // To Quoted Printable
        //**********************************************************************

        public static string ToQuotedPrintable(string input, Encoding fromCharsetEncoding)
        {
            try
            {
                var sb = new StringBuilder();
                var body = fromCharsetEncoding.GetBytes(input);
                int wrap = 0;
                int check = 0;

                for (int index = 0; index < body.Length; index++)
                {
                    if (wrap == 0 && index + 73 - check < body.Length)
                    {
                        while (body[index + 73 - check] == 46)
                        {
                            wrap++;
                            check++;
                            if (wrap == 72 || index + 73 - check >= body.Length)
                                break;
                        }
                        check = 0;
                    }

                    byte decim = body[index];
                    if ((decim < 33 || decim == 61 || decim > 126) && decim != 32)
                    {
                        sb.Append("=" + decim.ToString("X").PadLeft(2, '0'));
                    }
                    else
                    {
                        sb.Append((char)decim);
                    }

                    if (wrap >= 72)
                    {
                        sb.Append("=\r\n");
                        wrap = 0;
                    }
                    else
                    {
                        wrap++;
                    }
                }

                var ret = sb.ToString();
                return ret;
            }
            catch (Exception ex)
            {
                return input;
            }
        }

        //**********************************************************************
        // From Quoted Printable
        //**********************************************************************

        public static string FromQuotedPrintable(string input, Encoding toCharsetEncoding)
        {
            try
            {
                input = input.Replace("=\r\n", "") + "=3D=3D";
                var decoded = new List<byte>();
                int i = 0;

                while (true)
                {
                    if ((input.Length - 3) < i) break;

                    if (input[i] == '=' && input[i + 1] != '=')
                    {
                        var hexStr = string.Concat(input[i + 1], input[i + 2]);
                        var hexVal = int.Parse(hexStr, NumberStyles.HexNumber);
                        var b = Convert.ToByte(hexVal);
                        decoded.Add(b);
                        i += 3;
                    }
                    else
                    {
                        decoded.Add((byte)input[i]);
                        i++;
                    }
                }

                var ret = toCharsetEncoding.GetString(decoded.ToArray()).TrimEnd('=');
                return ret;
            }
            catch (Exception ex)
            {
                return input;
            }
        }
    }
}
