﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;

namespace Ozeki
{
    public static partial class OzCommonStrings
    {
        private static readonly Random Random = new Random();

      
        public static int RandomInt(int max)
        {
            return Random.Next(0, max);
        }

        public static string RandomIntString()
        {
            var randomNumber = Random.Next(0, int.MaxValue - 1);
            return randomNumber.ToString();
        }

        public static string RandomIntString(int length)
        {
            var builder = new StringBuilder();
            var randomNumber = Random.Next(1, 10);
            builder.Append(randomNumber);
            for (var x = 1; x < length; x++)
            {
                randomNumber = Random.Next(0, 10);
                builder.Append(randomNumber);
            }
            return builder.ToString();
        }



        

        //***********************************************
        // No cache string
        //***********************************************

     
        public static string NoCacheRandomStringRemove(string url)
        {
            if (string.IsNullOrEmpty(url)) return string.Empty;
            var position = url.IndexOf("&ncrefresh");
            if (position == -1) return url;
            var prefix = url.Substring(0, position);
            var postfix = url.Substring(position + 1);
            var positionNext = postfix.IndexOf("&");
            if (positionNext == -1) return prefix;
            postfix = postfix.Substring(positionNext);
            return prefix + postfix;
        }

        public static bool NoCacheRandomStringPresent(string url)
        {
            var position = url.IndexOf("&ncrefresh");
            if (position == -1) return false;
            return true;
        }

        public static string NoCacheRandomStringID(string url)
        {
            if (string.IsNullOrEmpty(url)) return string.Empty;
            var position = url.IndexOf("&ncrefresh");
            if (position == -1) return url;
            var prefix = url.Substring(0, position);
            var postfix = url.Substring(position + 1);
            var positionNext = postfix.IndexOf("&");
            if (positionNext == -1) 
                return postfix.Replace("ncrefresh", "").Replace("=", "");
            postfix = postfix.Substring(0,positionNext);
            return postfix.Replace("ncrefresh", "").Replace("=","");
        }




    }
}