﻿using System;
using System.Collections.Generic;
using System.Text.RegularExpressions;

namespace Ozeki
{
    partial class OzCommonStrings
    {
        public static string SQLEscape(string str)
        {
            return Regex.Replace(str, @"[\x00'""\b\n\r\t\cZ\\%_]",
            match =>
            {
                switch (match.Value)
                {
                    case "\x00":
                        return "\\0";
                    case "\t":
                        return "\\t";
                    case "\b":
                        return "\\b";
                    case "\n":
                        return "\\n";
                    case "\r":
                        return "\\r";
                    case "\u001A":
                        return "\\Z";
                    default:
                        return "\\" + match.Value;
                }
            });
        }
    }
}
