﻿
using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Globalization;
using System.Security.Cryptography;
using System.Text;
using System.IO;

namespace Ozeki
{
    public static partial class OzCommonStrings
    {
        public static void StreamMakeString(string pattern, int cn, StringBuilder dest)
        {
            for (var x = 0; x < cn; x++)
            {
                dest.Append(pattern);
            }
        }


        public static void StreamWriteTailPadded(string data, string fillpattern, int cn, StringBuilder dest)
        {
            dest.Append(data);
            for (var x = 0 + data.Length; x < cn; x++)
            {
                dest.Append(fillpattern);
            }
        }

        public static void StreamWriteFrontPadded(string data, string fillpattern, int cn, StringBuilder dest)
        {
            for (var x = 0 + data.Length; x < cn; x++)
            {
                dest.Append(fillpattern);
            }
            dest.Append(data);
        }

        public static string PadLeft(string s, char padchar, int len = 4)
        {
            var lens = s.Length;
            var padc = len - lens;
            if (padc < 1) return s;
            var ret = new StringBuilder();
            for (int x = 0; x < padc; x++)
                ret.Append(padchar);
            ret.Append(s);
            return ret.ToString();
        }

        public static string StreamToString(Stream stream, bool setPositionToFront=true)
        {
            if (setPositionToFront) stream.Position = 0;
            using (StreamReader reader = new StreamReader(stream, Encoding.UTF8))
            {
                return reader.ReadToEnd();
            }
        }

        public static Stream StringToStream(string src)
        {
            byte[] byteArray = Encoding.UTF8.GetBytes(src);
            return new MemoryStream(byteArray);
        }
    }
}
