﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Globalization;
using System.IO;
using System.Security.Cryptography;
using System.Text;
using System.Text.RegularExpressions;

namespace Ozeki
{
    public static partial class OzCommonStrings
    {
        public static ArrayList GetKeys(string template)
        {
            template = template.Replace("\r", " ");
            template = template.Replace("\n", " ");
            var keys = template.Split('$');
            var ret = new ArrayList();
            for (int x = 1; x < keys.Length; x++)
            {
                var textpart = keys[x];
                var rx = new Regex(@"([A-Z_0-9a-z/-]*)(.*)");
                textpart = rx.Replace(textpart, "$1", 1);
                ret.Add(textpart);
            }

            return ret;
        }

        static readonly Regex TemplateRegex = new Regex(@"\${[\x41-\x5A\x61-\x7A\x80-\xFF-_]+(\s?[\x41-\x5A\x61-\x7A\x80-\xFF-_]+)*}");
        static readonly char[] trimChars = new char[] { '{', '}', '$' };

        public static Dictionary<string, string> GetMatchedTemplateKeys(string text)
        {
            //var pattern = @"\${[A-Za-z0-9-_][A-Za-z0-9\s-_]*[A-Za-z0-9-_]}|\${[A-Za-z0-9]}";
          //  var pattern = @"\${[\x41-\x5A\x61-\x7A\x80-\xFF-_]+(\s?[\x41-\x5A\x61-\x7A\x80-\xFF-_]+)*}";
           // var matches = Regex.Matches(text, pattern);
            var matches = TemplateRegex.Matches(text);

            var _diction = new Dictionary<string, string>();

            foreach (Match match in matches)
            {
                var value = match.Value;
                //   var key = value.Trim("{}$".ToCharArray());
                var key = value.Trim(trimChars);
                if(!_diction.ContainsKey(key))
                    _diction.Add(key, match.Value);
            }

            return _diction;
        }


        public static void GetTemplateKeys(string template, ArrayList keys)
        {
            string[] parts = ("START" + template).Split('$');
            for (int x = 1; x < parts.Length; x++)
            {
                var key = String.Empty;
                var part = parts[x];
                var y = 0;
                while ((y < part.Length) && (WordChar(part[y])))
                {
                    key += part[y++];
                }
                if (key.Length > 0)
                {
                    keys.Add(key);
                }
            }
        }

    }
}
