﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Ozeki
{
    public static partial class OzCommonStrings
    {
        public static string Ucs2ToString(string ucs2Text)
        {
            var ret = new StringBuilder();
            for (var x = 0; x < ucs2Text.Length - 1; x += 2)
            {
                int b1 = ucs2Text[x + 1];
                int b2 = ucs2Text[x];
                var ucs2 = (b2 << 8) + b1;

                if (ucs2 < 0x80)
                {
                    ret.Append((char)b1);
                }
                else if (ucs2 >= 0x80 && ucs2 < 0x800)
                {
                    var vv = new[]
                                 {
                                     (byte) ((ucs2 >> 6) | 0xC0),
                                     (byte) ((ucs2 & 0x3F) | 0x80)
                                 };
                    ret.Append(Encoding.UTF8.GetString(vv));
                }
                else if (ucs2 >= 0x800 && ucs2 < 0xFFFF)
                {
                    var vv = new[]
                                 {
                                     (byte) (((ucs2 >> 12)) | 0xE0),
                                     (byte) (((ucs2 >> 6) & 0x3F) | 0x80),
                                     (byte) (((ucs2) & 0x3F) | 0x80)
                                 };

                    ret.Append(Encoding.UTF8.GetString(vv));
                }
            }
            return ret.ToString();
        }

        public static string String2Ucs2(string text)
        {
            var bytes = Encoding.Unicode.GetBytes(text);
            var resp = new StringBuilder();

            for (var x = 0; x < bytes.Length; x += 2)
            {
                resp.Append((char)bytes[x + 1]);
                resp.Append((char)bytes[x]);
            }
            return resp.ToString();

        }
    }
}
