﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Ozeki
{
    public static partial class OzCommonStrings
    {

        /// <summary>
        /// Converts the String to UTF8 Byte array and is used in De serialization
        /// </summary>
        /// <param name="pXmlString"></param>
        /// <returns></returns>
        public static Byte[] StringToUtf8ByteArray(String pXmlString)
        {
            var byteArray = Encoding.UTF8.GetBytes(pXmlString);
            return byteArray;
        }

        public static string StringToUtf8String(string input)
        {
            Byte[] b = StringToUtf8ByteArray(input);
            return ByteArrayToString(b);
        }

        /// <summary>
        /// To convert a Byte Array of Unicode values (UTF-8 encoded) to a complete String.
        /// </summary>
        /// <param name="characters">Unicode Byte Array to be converted to String</param>
        /// <returns>String converted from Unicode Byte Array</returns>
        public static String Utf8ByteArrayToString(Byte[] characters)
        {
            var constructedString = Encoding.UTF8.GetString(characters);
            return constructedString;
        }

        public static string EncodeToBase64String(string plainText)
        {
            try
            {
                var plainTextBytes = Encoding.UTF8.GetBytes(plainText); //- nem jó, veszteséges
                return Convert.ToBase64String(plainTextBytes);
            }
            catch { return string.Empty; }
        }

        public static string DecodeFromBase64String(string encodedData)
        {
            try
            {
                var encodedBytes = Convert.FromBase64String(encodedData);
                return Encoding.UTF8.GetString(encodedBytes); //- nem jó, veszteséges
            }
            catch { return string.Empty; }
        }


        public static string EncodeToBase64StringNoLoss(string plainText)
        {
            try
            {
                var plainTextBytes = GetBytes(plainText);
                return Convert.ToBase64String(plainTextBytes);
            }
            catch { return string.Empty; }
        }

        public static string DecodeFromBase64StringNoLoss(string encodedData)
        {
            try
            {
                var encodedBytes = Convert.FromBase64String(encodedData);
                return GetString(encodedBytes);
            }
            catch { return string.Empty; }
        }
    }
}
