﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Globalization;
using System.IO;
using System.Security.Cryptography;
using System.Text;
using System.Text.RegularExpressions;
using System.Web;
using System.Xml;

namespace Ozeki
{
    public static partial class OzCommonStrings
    {
        public static string GetWithoutSurroundingQuotes(string s)
        {
            if (s.Length>2 && s.StartsWith("\"") && s.EndsWith("\""))
            {
                return s.Substring(1, s.Length - 2);
            }
            if (s.Length > 2 && s.StartsWith("'") && s.EndsWith("'"))
            {
                return s.Substring(1, s.Length - 2);
            }
            return s;
        }

        public static string ChopQuotedVar(ref string input, char quoteCharStart = '"', char quoteCharEnd = (char)0)
        {
            input = input.Trim();
            if (quoteCharEnd == (char)0) quoteCharEnd = quoteCharStart;
            var var = GetQuotedVar(input,true, quoteCharStart,quoteCharEnd);
            if (!string.IsNullOrEmpty(var))
            {
                input = input.Substring(var.Length);
            }
            if (var.StartsWith(quoteCharStart.ToString())) var = var.Substring(1, var.Length - 2);
            return var;
        }

        public static string GetQuotedVar(string input, bool includeQuotes=false, char quoteCharStart = '"', char quoteCharEnd = (char)0)
        {
            if (quoteCharEnd == (char)0) quoteCharEnd = quoteCharStart;
            if (string.IsNullOrEmpty(input)) return input;
            input = input.Trim();
            if (string.IsNullOrEmpty(input)) return input;
            bool inQuote = false;
            int x = 0;
            int l = input.Length;
            var ret = new StringBuilder();
            if (input.StartsWith(quoteCharStart.ToString()))
            {
                x++;
                inQuote = true;
            }
            while (x < l)
            {
                if (!inQuote && isSeparatorChar(input[x])) return ret.ToString();
                if (input[x] == quoteCharEnd)
                {
                    if (includeQuotes) return quoteCharStart.ToString() + ret.ToString() + quoteCharEnd.ToString();
                    return ret.ToString();
                }
                ret.Append(input[x]);
                x++;
            }
            if (inQuote) return "";
            return ret.ToString();
        }

        static bool isSeparatorChar(char c)
        {
            if (c == ' ') return true;
            if (c == ',') return true;
            if (c == ';') return true;
            if (c == Cr) return true;
            if (c == Lf) return true;

            return false;
        }
    }
}
