﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Globalization;
using System.IO;
using System.Security.Cryptography;
using System.Text;
using System.Text.RegularExpressions;
using System.Web;
using System.Xml;

namespace Ozeki
{
    public static partial class OzCommonStrings
    {
        public static string BeautifyXML(string xml)
        {
            if (String.IsNullOrEmpty(xml)) return null;
            XmlDocument doc = new XmlDocument();
            doc.LoadXml(xml);
            return BeautifyXML(doc);
        }

        static XmlWriterSettings _xmlSettings = new XmlWriterSettings
        {
            Indent = true,
            IndentChars = "  ",
            NewLineChars = "\r\n",
            NewLineHandling = NewLineHandling.Replace
        };

        public static string BeautifyXML(this XmlDocument doc)
        {
            StringBuilder sb = new StringBuilder();
          
            using (XmlWriter writer = XmlWriter.Create(sb, _xmlSettings))
            {
                doc.Save(writer);
            }

            return sb.ToString();
        }

        public static string XmlStringEncode(string input)
        {
            return input.
                Replace("&", "&amp;").
                Replace("<", "&lt;").
                Replace(">", "&gt;").
                Replace("\'", "&apos;").
                Replace("\"", "&quot;");
        }
    }
}
