﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Ozeki
{
    public static partial class OzCommonStrings
    {

        public static int Crc16(string s, Encoding encoding = null)
        {
            ushort crc = 0xFFFF;
            if (encoding == null) encoding = Encoding.ASCII;
            byte[] data = encoding.GetBytes(s);
            for (int i = 0; i < data.Length; i++)
            {
                var x = ((crc >> 8) ^ data[i]) & 0xFF;
                x ^= x >> 4;
                crc = (ushort)(((crc << 8) ^ (x << 12) ^ (x << 5) ^ x) & 0xFFFF);
            }
            return (int)crc;
        }

        public static int Crc16v2(string s, Encoding encoding = null)
        {
            ushort crc = 0x000;
            if (encoding == null) encoding = Encoding.ASCII;
            byte[] data = encoding.GetBytes(s);
            for (int i = 0; i < data.Length; i++)
            {
                crc ^= (ushort)(data[i] << 8);
                for (int j = 0; j < 8; j++)
                {
                    if ((crc & 0x8000) > 0)
                        crc = (ushort)((crc << 1) ^ 0x8005);
                    else
                        crc <<= 1;
                }
            }
            return (int)crc;
        }

       
    }
}