﻿using System;
using System.Globalization;
using System.Text.RegularExpressions;

namespace Ozeki
{
    partial class OzDateTime
    {
        public static int DayNumber(DateTime today)
        {
            var dow = today.DayOfWeek;
            if (dow == DayOfWeek.Sunday) return 7;
            if (dow == DayOfWeek.Saturday) return 6;
            if (dow == DayOfWeek.Friday) return 5;
            if (dow == DayOfWeek.Thursday) return 4;
            if (dow == DayOfWeek.Wednesday) return 3;
            if (dow == DayOfWeek.Tuesday) return 2;
            if (dow == DayOfWeek.Monday) return 1;
            return 0;
        }

        public static string DayString(int dayNumber)
        {
            switch (dayNumber)
            {
                case 0: return "Sunday";
                case 1: return "Monday";
                case 2: return "Tuesday";
                case 3: return "Wednesday";
                case 4: return "Thursday";
                case 5: return "Friday";
                case 6: return "Saturday";
                case 7: return "Sunday";
            }
            return "";
        }


        public static DateTime MondayOfThisWeek(DateTime today)
        {
            var dow = OzDateTime.DayNumber(today);
            var dateMondayWithTime = today.AddDays(-1 * (dow - 1));
            var dateMonday = new DateTime(dateMondayWithTime.Year, dateMondayWithTime.Month, dateMondayWithTime.Day);
            return dateMonday;
        }

        public static DateTime SundayOfThisWeek(DateTime today)
        {
            var dow = OzDateTime.DayNumber(today);
            var dateWithTime = today.AddDays(7 - dow);
            var dateSunday = new DateTime(dateWithTime.Year, dateWithTime.Month, dateWithTime.Day);
            return dateSunday;
        }

        public static bool IsSameWeek(DateTime date1, DateTime date2)
        {
            var mon1 = MondayOfThisWeek(date1);
            var mon2 = MondayOfThisWeek(date2);
            if (mon1 == mon2) return true;
            return false;
        }
    }
}
