﻿using System;
using System.Globalization;
using System.Text.RegularExpressions;

namespace Ozeki
{
    partial class OzDateTime
    {
        // Date and Time Specification, https://tools.ietf.org/html/rfc2822.html#section-3.3

        public static string[] Days = { "Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat" };

        public static string[] Months = { "Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec" };

        public static string ToEmailDate(DateTime date)
        {
            var dayName = Days[(int)date.DayOfWeek];
            var monthName = Months[date.Month - 1];
            var ret = dayName + date.ToString(", d ") + monthName + " " + date.ToString("yyyy HH:mm:ss zz") + "00";
            return ret;
        }
    }
}
