﻿using System;
using System.Globalization;
using System.Text.RegularExpressions;

namespace Ozeki
{
    partial class OzDateTime
    {
        public static DateTime epoch = new DateTime(1970, 1, 1, 0, 0, 0, 0);

        public static bool UnixToDateTime(string unixt, out DateTime dt)
        {
            if (!double.TryParse(unixt, out var unixd))
            {
                dt = OzDateTime.Now;
                return false;
            }

            dt = UnixToDateTime(unixd);
            return true;
        }

        public static DateTime UnixToDateTime(double unixt)
        {
            var d = epoch.AddSeconds(unixt);
            return d;
        }

        public static Int64 DateTimeToUnix(DateTime dt)
        {
            var d = dt - epoch;
            return (Int64)d.TotalSeconds;
        }

    }
}
