﻿using System.Runtime.Serialization;
using System.Net;
using System;

namespace Ozeki
{
    public class OzConf_Proxy
    {
        const string TABPAGE_ADVANCED = "Advanced";
        const string GROUPBOX_PROXY_SERVER = "HTTP Proxy";

        public bool IsProxyEnabled { get; set; }

        public string ProxyHost { get; set; }

        public int ProxyPort { get; set; }

        public string ProxyUsername { get; set; }

        public string ProxyPassword { get; set; }

        //************************************************************************************
        // Init
        //************************************************************************************

        public OzConf_Proxy()
        {
            IsProxyEnabled = false;
            ProxyPort = 8080;
        }

        //************************************************************************************
        // Convert to IWebProxy
        //************************************************************************************
        public IWebProxy ToWebProxy()
        {
            if (!IsProxyEnabled) return null;
            if (string.IsNullOrEmpty(ProxyHost)) return null;
            NetworkCredential credential = new NetworkCredential(ProxyUsername, ProxyPassword);
            WebProxy webProxy = new WebProxy(ProxyHost, ProxyPort);
            webProxy.BypassProxyOnLocal = true;
            webProxy.Credentials = credential;
            return webProxy;
        }
    }
}