﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Ozeki
{
    public static partial class OzHttpClient
    {
        public static bool LogRequests = false;

        public static bool HttpDownload(string url, HTTPRequestMethod requestMethod, out string responseData, out string log, OzConf_HttpClient config = null)
        {
            if ((requestMethod == HTTPRequestMethod.POST) && url.Contains("?"))
            {
                string[] targetURLSplit = url.Split("?".ToCharArray(), 2);
                var targetURLBase = targetURLSplit[0];
                var postdata = targetURLSplit[1];
                return HttpDownload(targetURLBase, requestMethod, postdata, out responseData, out log, config);
            }
            return HttpDownload(url, requestMethod, null, out responseData, out log, config);
        }

        public static bool HttpDownload(string url, HTTPRequestMethod requestMethod, string postdata, out string responseData, out string log, OzConf_HttpClient config = null)
        {
            var ret = HttpDownload(url, requestMethod, postdata, out responseData, out var responseHeaders, out log, out string error, config);
            log = error ?? "" + log ?? "";
            return ret;
        }

        //***************************************************************************
        // Main HTTP Download function
        //***************************************************************************

        public static bool HttpDownload(string url, HTTPRequestMethod requestMethod, string postdata, out string responseData, out Dictionary<string, string> responseHeaders, out string log, out string error, OzConf_HttpClient proxyConfig = null, Dictionary<string, string> RequestHeaders = null)
        {
            var downloadParams = new OzHttpDownloadParams();
            downloadParams.Url = url;
            downloadParams.RequestMethod = requestMethod;
            downloadParams.PostData = postdata;
            downloadParams.ProxyConfig = proxyConfig;
            downloadParams.RequestHeaders = RequestHeaders;
            downloadParams.DisableCertificateValidation = true;

            var ret = HttpDownload(downloadParams);
            responseData = downloadParams.ResponseString;
            responseHeaders = downloadParams.ResponseHeaders;
            error = downloadParams.Error;
            log = downloadParams.Log;
            return ret;
        }
    }
}