﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Security;
using System.Security.Cryptography.X509Certificates;
using System.Text;
using System.Threading.Tasks;

namespace Ozeki
{
    partial class OzHttpClient
    {
        public const string UseragentChrome = "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/92.0.4515.159 Safari/537.36";

        static void setupOzekiHeaders(OzHttpDownloadParams downloadParams)
        {
            if (downloadParams.DisableAttachOzekiHeaders && !downloadParams.RequestHeaders.ContainsKey("User-Agent"))
            {
                downloadParams.RequestHeaders.Add("User-Agent", UseragentChrome);
            }

            if (downloadParams.DisableAttachOzekiHeaders)
            { 
                return;
            }

        }

        static void setupCustomHeaders(WebHeaderCollection headers, OzHttpDownloadParams downloadParams, bool skipUserAgent = false)
        {
            if (skipUserAgent)
            {
                downloadParams.RequestHeaders.Remove("User-Agent");
                downloadParams.RequestHeaders.Remove("Accept");
                downloadParams.RequestHeaders.Remove("Content-Type");
                downloadParams.RequestHeaders.Remove("Referer");
                downloadParams.RequestHeaders.Remove("Host");
                downloadParams.RequestHeaders.Remove("Connection");
                return;
            }

            foreach (var kvp in downloadParams.RequestHeaders)
            {
                headers.Remove(kvp.Key);
                headers.Add(kvp.Key, kvp.Value);
            }
        }
    }
}
