﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net;
using System.Net.Security;
using System.Security.Cryptography.X509Certificates;
using System.Text;
using System.Threading.Tasks;

namespace Ozeki
{
    static partial class OzHttpClient
    {
        static void logRequest(HTTPRequestMethod requestMethod, string targetURLBase, Dictionary<string,string> requestHeaders, string postData, StringBuilder logData)
        {
            logData.AppendLine(requestMethod + " " + targetURLBase + " HTTP/1.1");
            foreach (var header in requestHeaders)
            {
                logData.AppendLine(header.Key+": "+header.Value);
            }
            logData.AppendLine();
            logData.Append(postData);
        }

        static void logResponse(string responseFirstLine, string responseHeader, string responseData, StringBuilder logData)
        {
            logData.AppendLine(responseFirstLine);
            logData.Append(responseHeader);
            logData.Append(responseData);
        }
    }
}
