﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading.Tasks;

namespace Ozeki
{
    partial class OzHttpClient
    {
        //**************************************************************
        // Notify progress monitor
        //**************************************************************

        static void notifyMonitorAboutDownloadStarted(OzHttpDownloadParams downloadParams)
        {
            if (downloadParams.ProgressMonitor == null) return;
            downloadParams.ProgressMonitor.Started(downloadParams);
        }

        static void notifyMonitorAboutProgressChanged(OzHttpDownloadParams downloadParams, WebClientEx client, DownloadProgressChangedEventArgs e)
        {
            if (downloadParams.ProgressMonitor == null) return;
            var total = e.TotalBytesToReceive;
            var completed = e.BytesReceived;
            downloadParams.ProgressMonitor.ProgressUpdated_Download(client.Progress, completed, total, downloadParams);
        }

        static void notifyMonitorAboutProgressChanged(OzHttpUploadParams uploadParams, WebClientEx client, UploadProgressChangedEventArgs e)
        {
            if (uploadParams.ProgressMonitor == null) return;
            var total = e.TotalBytesToReceive;
            var completed = e.BytesReceived;
            uploadParams.ProgressMonitor.ProgressUpdated_Download(client.Progress, completed, total, uploadParams);
        }

        static void notifyMonitorAboutDownloadCompleted(OzHttpDownloadParams downloadParams)
        {
            if (downloadParams.ProgressMonitor == null) return;
            if (!string.IsNullOrEmpty(downloadParams.Error))
            {
                downloadParams.ProgressMonitor.Failed(downloadParams);
                return;
            }
            downloadParams.ProgressMonitor.Completed(downloadParams);
        }
    }
}
