﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Ozeki
{
    public class OzProgressMonitorWithEventLog : OzProgressMonitor
    {
        OzLogSource[] _logSource;
        string _logMessagePrefix;

        public OzProgressMonitorWithEventLog(OzLogSource[] logSource, string logMessagePrefix) : base()
        {
            _logSource = logSource;
            _logMessagePrefix = logMessagePrefix;
        }

        public OzProgressMonitorWithEventLog(OzLogSource logSource, string logMessagePrefix) : base()
        {
            _logSource = new OzLogSource[] { logSource };
            _logMessagePrefix = logMessagePrefix;
        }

        public override void Started(object stateObject)
        {
            OzLogger.Log(_logSource, LogLevel.Information, _logMessagePrefix + " started.");
            base.Started(stateObject);
        }

        public override void ProgressUpdated_Download(int percent, long completedData, long totalData, object stateObject)
        {
            OzLogger.Log(_logSource, LogLevel.Information, _logMessagePrefix + " progress: " + percent + "%");
            base.ProgressUpdated_Download(percent, completedData, totalData, stateObject);
        }

        public override void Completed(object stateObject)
        {
            OzLogger.Log(_logSource, LogLevel.Information, _logMessagePrefix + " completed.");
            base.Completed(stateObject);
        }

        public override void Failed(object stateObject)
        {
            OzLogger.Log(_logSource, LogLevel.Warning, _logMessagePrefix + " failed.");
            base.Failed(stateObject);
        }
    }
}
