﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Security;
using System.Security.Cryptography.X509Certificates;
using System.Text;
using System.Threading.Tasks;

namespace Ozeki
{
    public class OzServerCertValidation
    {
        public bool SSLAcceptAllCertificates { get; private set; }

        public static OzServerCertValidation SetServerValidation(HttpWebRequest request, bool acceptallcert)
        {
            return new OzServerCertValidation(request, acceptallcert);
        }

        OzServerCertValidation(HttpWebRequest request, bool acceptallcert)
        {
            SSLAcceptAllCertificates = acceptallcert;
            request.ServerCertificateValidationCallback = OnValidateCertificate;
        }

        bool OnValidateCertificate(object sender, X509Certificate certificate, X509Chain chain, SslPolicyErrors sslPolicyErrors)
        {
            if (SSLAcceptAllCertificates) return true;
            if (sslPolicyErrors == SslPolicyErrors.None) return true;
            return false;
        }
    }
}