﻿using Ozeki;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace System.Net
{
    public class WebClientEx : WebClient
    {
        public ManualResetEvent Semafor;
        public int Timeout;
        public int Progress;
        public bool KeepAlive;
        public DateTime StartTime;
        public object StateObject;
        public bool DisableExpect100Continue;
        public byte[] Response { get; private set; }

        public WebClientEx() : base()
        {
            Semafor = new ManualResetEvent(false);
        }

        protected override WebRequest GetWebRequest(Uri address)
        {
            var request = base.GetWebRequest(address);
            request.Timeout = Timeout;
            StartTime = DateTime.Now;
            if (request is HttpWebRequest httpWebRequest)
            {
                httpWebRequest.KeepAlive = KeepAlive;
                httpWebRequest.ServicePoint.Expect100Continue = !DisableExpect100Continue;
            }
            OzWebRequestExecutor.Instance.ManageRequestTimeout(this);
            return request;
        }


        protected override WebResponse GetWebResponse(WebRequest request)
        {
            var response = base.GetWebResponse(request);
            var httpResponse = response as HttpWebResponse;
            if (httpResponse != null)
            {
                using (var stream = httpResponse.GetResponseStream())
                {
                    using (var ms = new MemoryStream())
                    {
                        stream.CopyTo(ms);
                        Response = ms.ToArray();
                    }
                }
            }
            return response;
        }
    }
}
