﻿using System;

namespace Ozeki
{
    /// <summary>
    /// Defines constants for specifying the logging levels.
    /// </summary>
    [Serializable]
    public enum LogLevel : byte
    {
        /// <summary>
        ///  Error conditions
        /// </summary>
        Error,
        /// <summary>
        /// Warning conditions
        /// </summary>
        Warning,
        /// <summary>
        /// Informational messages
        /// </summary>
        Information,
        /// <summary>
        /// Debug-level messages
        /// </summary>
        Debug,
        /// <summary>
        /// Trace-level messages
        /// </summary>
        Trace,
        /// <summary>
        /// No log messages
        /// </summary>
        None
    }
}